Index: trunk/MagicSoft/Cosy/catalog/SlaPlanets.cc
===================================================================
--- trunk/MagicSoft/Cosy/catalog/SlaPlanets.cc	(revision 9522)
+++ trunk/MagicSoft/Cosy/catalog/SlaPlanets.cc	(revision 9523)
@@ -9,5 +9,5 @@
 using namespace std;
 
-SlaPlanets::SlaPlanets(MObservatory::LocationName_t key) : SlaStars(key), fDt(slaDt(2000.0)/60./60./24.)
+SlaPlanets::SlaPlanets(MObservatory::LocationName_t key) : SlaStars(key)//, fDt(slaDt(2000.0)/60./60./24.)
 {
 }
@@ -17,9 +17,8 @@
     SlaStars::SetMjd(mjd);
 
-    fTt = GetMjd() + slaDtt(GetMjd())/60./60./24.;
-
     //
-    // coordinates of earth: heliocentric, equatoril, J2000
+    // coordinates of earth: heliocentric, equatorial, J2000
     //
+    /*
     double veb[3]; // barycentric velocity
     double ceb[3]; // barycentric coordinates
@@ -27,4 +26,5 @@
 
     slaEvp(GetMjd() + fDt, 2000.0, veb, ceb, veh, fEarth);
+    */
 }
 
@@ -40,5 +40,5 @@
     // One can use TT instead of TDB for all planets (except the moon?)
     // TDB, planet, elong, phi, *ra, *dec, *diam
-    slaRdplan(fTt, planet, GetElong(), GetPhi(), &ra, &dec, &diam);
+    slaRdplan(GetTT(), planet, GetElong(), GetPhi(), &ra, &dec, &diam);
 
     return RaDec(ra, dec);
Index: trunk/MagicSoft/Cosy/catalog/SlaPlanets.h
===================================================================
--- trunk/MagicSoft/Cosy/catalog/SlaPlanets.h	(revision 9522)
+++ trunk/MagicSoft/Cosy/catalog/SlaPlanets.h	(revision 9523)
@@ -27,12 +27,11 @@
 {
 private:
-    double fDt;        // [mjd] const: rootcint/TMemberInspector
-    double fTt;        // [mjd] timescale TT
+    //double fDt;        // [mjd] The result is a rough estimate of ET-UT (after 1984, TT-UT1) at the given epoch, in seconds
 
     ZdAz fZdAz[10];    // [rad]
 
-    double fEarth[3];  // heliocentric coordinates
+    //double fEarth[3];  // heliocentric coordinates
 
-    ZdAz   GetMoonPos() const;
+    //ZdAz   GetMoonPos() const;
 
 public:
Index: trunk/MagicSoft/Cosy/catalog/SlaStars.cc
===================================================================
--- trunk/MagicSoft/Cosy/catalog/SlaStars.cc	(revision 9522)
+++ trunk/MagicSoft/Cosy/catalog/SlaStars.cc	(revision 9523)
@@ -12,8 +12,4 @@
 }
 
-SlaStars::~SlaStars()
-{
-}
-
 void SlaStars::Set(const AltAz &altaz)
 {
@@ -42,4 +38,6 @@
     Slalib::SetMjd(mjd);
 
+    fTt = GetMjd() + slaDtt(GetMjd())/60./60./24.;
+
     //
     // ----- calculate star independent parameters ----------
@@ -47,5 +45,6 @@
 
     // prepare calculation: Mean Place to geocentric apperent
-    slaMappa(2000.0, GetMjd(), fAmprms);   // Epoche, TDB
+    // (UTC would also do, except for the moon?)
+    slaMappa(2000.0, fTt, fAmprms);        // Epoche, TDB
 
     // prepare: Apperent to observed place
@@ -54,8 +53,11 @@
              0, 0,                         // polar motion x, y-coordinate (radians)
              // 273.155, 1013.25, 0.5,     // temp, pressure, humidity
-             273.155+10, 780.0, 0.25,     // temp, pressure, humidity
+             273.155+10, 780.0, 0.25,      // temp, pressure, humidity
              // 0.2, 0.0065,               // wavelength, tropo lapse rate
              0.55, 0.0065,                 // wavelength, tropo lapse rate
              fAoprms);
+
+    // Delta UT should be less than 0.9s which is its definition
+    // so we can fairly assume it to be neglegible
 }
 
Index: trunk/MagicSoft/Cosy/catalog/SlaStars.h
===================================================================
--- trunk/MagicSoft/Cosy/catalog/SlaStars.h	(revision 9522)
+++ trunk/MagicSoft/Cosy/catalog/SlaStars.h	(revision 9523)
@@ -21,7 +21,9 @@
     double   fAoprms[14];
 
+    double   fTt;        // [mjd] timescale TT
+
 public:
     SlaStars(MObservatory::LocationName_t key);
-    virtual ~SlaStars();
+    virtual ~SlaStars() { }
 
     //    const AltAz GetAltAz() const { return fAltAz*360/D2PI; }
@@ -31,4 +33,6 @@
     const RaDec  GetRaDecRad() const  { return fRaDec; }
     const double GetHourAngle() const { return fHourAngle; }
+
+    const double GetTT() const        { return fTt; }
 
     virtual void SetMjd(double mjd);