Index: trunk/Mars/mimage/MHHillasExt.cc
===================================================================
--- trunk/Mars/mimage/MHHillasExt.cc	(revision 9851)
+++ trunk/Mars/mimage/MHHillasExt.cc	(revision 9854)
@@ -18,5 +18,5 @@
 !   Author(s): Thomas Bretz, 2001 <mailto:tbretz@astro.uni-wuerzburg.de>
 !
-!   Copyright: MAGIC Software Development, 2000-2007
+!   Copyright: MAGIC Software Development, 2000-2010
 !
 !
@@ -38,4 +38,11 @@
 //  - fMm2Deg
 //  - fUseMmScale
+//
+// ClassVersion 4:
+// ---------------
+//  + TH1F fHTimeSpread;      // [ns] Spread (rms) of arrival time around mean
+//  + TH1F fHTimeSpreadW;     // [ns] Weighted spread (rms) of arrival time around weighted mean
+//  + TH1F fHSlopeSpread;     // [ns] Spread (rms) of arrival time around slope
+//  + TH1F fHSlopeSpreadW;    // [ns] Weighted spread (rms) of arrival time around slope
 //
 /////////////////////////////////////////////////////////////////////////////
@@ -87,4 +94,8 @@
     fHM3Trans.UseCurrentStyle();
     fHSlopeL.UseCurrentStyle();
+    fHTimeSpread.UseCurrentStyle();
+    fHTimeSpreadW.UseCurrentStyle();
+    fHSlopeSpread.UseCurrentStyle();
+    fHSlopeSpreadW.UseCurrentStyle();
 
     fHAsym.SetName("Asymmetry");
@@ -92,4 +103,8 @@
     fHM3Trans.SetName("M3t");
     fHSlopeL.SetName("SlopeL");
+    fHTimeSpread.SetName("TimeSpread");
+    fHTimeSpreadW.SetName("TimeSpreadW");
+    fHSlopeSpread.SetName("SlopeSpread");
+    fHSlopeSpreadW.SetName("SlopeSpreadW");
 
     fHAsym.SetTitle("Asymmetry");
@@ -97,4 +112,8 @@
     fHM3Trans.SetTitle("3^{rd} Moment Transverse");
     fHSlopeL.SetTitle("Longitudinal time-slope vs. Dist");
+    fHTimeSpread.SetTitle("Time spread around mean");
+    fHTimeSpreadW.SetTitle("Weighted time spread around weighted mean");
+    fHSlopeSpread.SetTitle("Time spread around slope");
+    fHSlopeSpreadW.SetTitle("Weighted time spread around slope");
 
     fHAsym.SetXTitle("Asym [\\circ]");
@@ -102,4 +121,8 @@
     fHM3Trans.SetXTitle("3^{rd} M_{t} [\\circ]");
     fHSlopeL.SetXTitle("D [\\circ]");
+    fHTimeSpread.SetXTitle("T_{rms} [ns]");
+    fHTimeSpreadW.SetXTitle("T_{rms} [ns]");
+    fHSlopeSpread.SetXTitle("T_{rms} [ns]");
+    fHSlopeSpreadW.SetXTitle("T_{rms} [ns]");
 
     fHAsym.SetYTitle("Counts");
@@ -107,4 +130,8 @@
     fHM3Trans.SetYTitle("Counts");
     fHSlopeL.SetYTitle("S_{l} [ns/\\circ]");
+    fHTimeSpread.SetYTitle("Counts");
+    fHTimeSpreadW.SetYTitle("Counts");
+    fHSlopeSpread.SetYTitle("Counts");
+    fHSlopeSpreadW.SetYTitle("Counts");
 
     fHAsym.SetFillStyle(4000);
@@ -118,5 +145,16 @@
     fHSlopeL.SetDirectory(NULL);
 
+    fHTimeSpread.SetDirectory(NULL);
+    fHTimeSpreadW.SetDirectory(NULL);
+    fHSlopeSpread.SetDirectory(NULL);
+    fHSlopeSpreadW.SetDirectory(NULL);
+
     fHM3Trans.SetLineColor(kBlue);
+
+    fHSlopeSpread.SetLineColor(kBlue);
+    fHSlopeSpreadW.SetLineColor(kBlue);
+
+    fHTimeSpreadW.SetLineStyle(kDashed);
+    fHSlopeSpreadW.SetLineStyle(kDashed);
 
     MBinning binsx, binsy;
@@ -132,4 +170,11 @@
     binsy.SetEdges(100,  -9,   9);
     MH::SetBinning(fHSlopeL, binsx, binsy);
+
+    binsx.SetEdges( 50,   0, 1.5);
+    MH::SetBinning(fHTimeSpread,   binsx);
+    MH::SetBinning(fHSlopeSpread,  binsx);
+    binsx.SetEdges(150,   0, 1.5);
+    MH::SetBinning(fHTimeSpreadW,  binsx);
+    MH::SetBinning(fHSlopeSpreadW, binsx);
 }
 
@@ -172,4 +217,9 @@
     ApplyBinning(*plist, "Dist",    "Slope", fHSlopeL);
 
+    ApplyBinning(*plist, "TimeSpread",       fHTimeSpread);
+    ApplyBinning(*plist, "TimeSpreadW",      fHTimeSpreadW);
+    ApplyBinning(*plist, "TimeSpread",       fHSlopeSpread);
+    ApplyBinning(*plist, "TimeSpreadW",      fHSlopeSpreadW);
+
     return kTRUE;
 }
@@ -191,4 +241,9 @@
     fHM3Trans.Fill(scale*fHillasExt->GetM3Trans(), w);
     fHSlopeL.Fill(scale*dist, fHillasExt->GetSlopeLong()/scale, w);
+
+    fHTimeSpread.Fill(fHillasExt->GetTimeSpread(), w);
+    fHTimeSpreadW.Fill(fHillasExt->GetTimeSpreadWeighted(), w);
+    fHSlopeSpread.Fill(fHillasExt->GetSlopeSpread(), w);
+    fHSlopeSpreadW.Fill(fHillasExt->GetSlopeSpreadWeighted(), w);
 
     return kTRUE;
@@ -271,5 +326,13 @@
         fHSlopeL.Draw("colz");
 
-    delete pad->GetPad(4);
+    pad->cd(4);
+    gPad->SetBorderMode(0);
+    gPad->SetGridx();
+    gPad->SetGridy();
+
+    fHSlopeSpreadW.Draw();
+    fHTimeSpread.Draw("same");
+    fHSlopeSpread.Draw("same");
+    fHTimeSpreadW.Draw("same");
 }
 
Index: trunk/Mars/mimage/MHHillasExt.h
===================================================================
--- trunk/Mars/mimage/MHHillasExt.h	(revision 9851)
+++ trunk/Mars/mimage/MHHillasExt.h	(revision 9854)
@@ -20,8 +20,13 @@
     MHillasExt *fHillasExt; //! Pointer to the MHillasExt container
 
-    TH1F fHAsym;    // [mm]    fDist minus dist: center of ellipse, highest pixel
-    TH1F fHM3Long;  // [mm]    3rd moment (e-weighted) along major axis
-    TH1F fHM3Trans; // [mm]    3rd moment (e-weighted) along minor axis
-    TH2F fHSlopeL;  //
+    TH1F fHAsym;            // [mm] fDist minus dist: center of ellipse, highest pixel
+    TH1F fHM3Long;          // [mm] 3rd moment (e-weighted) along major axis
+    TH1F fHM3Trans;         // [mm] 3rd moment (e-weighted) along minor axis
+    TH2F fHSlopeL;          //
+
+    TH1F fHTimeSpread;      // [ns] Spread (rms) of arrival time around mean
+    TH1F fHTimeSpreadW;     // [ns] Weighted spread (rms) of arrival time around weighted mean
+    TH1F fHSlopeSpread;     // [ns] Spread (rms) of arrival time around slope
+    TH1F fHSlopeSpreadW;    // [ns] Weighted spread (rms) of arrival time around slope
 
     TString fHilName;
@@ -44,5 +49,5 @@
     void Draw(Option_t *opt=NULL);
 
-    ClassDef(MHHillasExt, 3) // Container which holds histograms for the extended hillas parameters
+    ClassDef(MHHillasExt, 4) // Container which holds histograms for the extended hillas parameters
 };
 