Index: trunk/Mars/resmc/fact-trigger-all.txt
===================================================================
--- trunk/Mars/resmc/fact-trigger-all.txt	(revision 9878)
+++ trunk/Mars/resmc/fact-trigger-all.txt	(revision 9878)
@@ -0,0 +1,162 @@
+#FACT Trigger-Patches (SoftIDs)
+    1025   917  1138  1024   916  1137  1023   915  1136  
+    1022   914  1135  1021   913  1134  1020   912  1133  
+    1145  1031  1144  1030   922  1029   921   819   920  
+    1148  1034  1147  1033   925  1032   924   822   923  
+     821   725   820   724   634   723   633   549   632  
+     548   470   547   469   397   546   468   396   545  
+     818   722   817   721   631   816   720   630   815  
+     719   629   814   718   628   813   717   627   812  
+     716   626   811   715   625   810   714   624   809  
+     467   395   544   466   394   543   465   393   542  
+    1151  1037  1150  1036   928  1035   927   825   926  
+     824   728   823   727   637   726   636   552   635  
+     551   473   550   472   400   471   399   333   398  
+     332   272   331   271   217   330   270   216   329  
+     269   215   328   268   214   327   267   213   326  
+     464   392   541   463   391   540   462   390   539  
+    1154  1040  1153  1039   931  1038   930   828   929  
+     827   731   826   730   640   729   639   555   638  
+     554   476   553   475   403   474   402   336   401  
+     335   275   334   274   220   273   219   171   218  
+     170   128   169   127    91   168   126    90   167  
+     173   131   172   130    94   129    93    63    92  
+      62    38    61    37    19    60    36    18    59  
+    1157  1043  1156  1042   934  1041   933   831   932  
+     830   734   829   733   643   732   642   558   641  
+     557   479   556   478   406   477   405   339   404  
+     338   278   337   277   223   276   222   174   221  
+     833   834   832   736   737   735   645   646   644  
+     560   561   559   481   482   480   408   409   407  
+     341   342   340   280   281   279   225   226   224  
+     176   177   175   133   134   132    96    97    95  
+      65    66    64    40    41    39    21    22    20  
+      68    69    42    43    44    23    24    45    10  
+       8     9     7     1     2     6     0     3     5  
+     344   345   282   283   284   227   228   229   178  
+     179   180   135   136   137    98    99   100    67  
+     182   183   138   139   140   101   102   141    70  
+     103   142    71   104   143    72   105   144    73  
+    1163  1164  1047  1048  1049   938   939   940   835  
+     836   837   738   739   740   647   648   649   562  
+     563   564   483   484   485   410   411   412   343  
+    1166  1167  1050  1051  1052   941   942   943   838  
+     839   840   741   742   743   650   651   652   565  
+     566   567   486   487   488   413   414   415   346  
+     347   348   285   286   287   230   231   232   181  
+     350   351   288   289   290   233   234   291   184  
+     421   496   353   422   497   354   423   498   355  
+     235   292   185   236   293   186   237   294   187  
+    1169  1170  1053  1054  1055   944   945   946   841  
+     842   843   744   745   746   653   654   655   568  
+     569   570   489   490   491   416   417   418   349  
+     661   754   575   662   755   576   663   756   577  
+     664   757   578   665   758   579   666   759   580  
+     958  1069   854   959  1070   855   960  1071   856  
+     961  1072   857   962  1073   858   963  1074   859  
+    1172  1173  1056  1057  1058   947   948   949   844  
+     845   846   747   748   749   656   657   658   571  
+     572   573   492   493   494   419   420   495   352  
+    1175  1176  1059  1060  1061   950   951   952   847  
+     848   849   750   751   752   659   660   753   574  
+     955  1066   851   956  1067   852   957  1068   853  
+     967  1078   863   968  1079   864   969  1080   865  
+     964  1075   860   965  1076   861   966  1077   862  
+     769   868   770   869   974   870   975  1086   976  
+     772   871   773   872   977   873   978  1089   979  
+     508   589   509   590   677   591   678   771   679  
+     430   505   362   431   506   363   432   507   433  
+     673   766   587   674   767   588   675   768   676  
+     670   763   584   671   764   585   672   765   586  
+     427   502   359   428   503   360   429   504   361  
+     667   760   581   668   761   582   669   762   583  
+     775   874   776   875   980   876   981  1092   982  
+     511   592   512   593   680   594   681   774   682  
+     301   364   302   365   434   366   435   510   436  
+     241   298   191   242   299   192   243   300   244  
+     238   295   188   239   296   189   240   297   190  
+     424   499   356   425   500   357   426   501   358  
+     778   877   779   878   983   879   984  1095   985  
+     514   595   515   596   683   597   684   777   685  
+     304   367   305   368   437   369   438   513   439  
+     148   193   149   194   245   195   246   303   247  
+     106   145    74   107   146    75   108   147   109  
+      49    76    50    77   110    78   111   150   112  
+      25    46    11    26    47    12    27    48    28  
+     781   880   782   881   986   882   987  1098   988  
+     517   598   518   599   686   600   687   780   688  
+     307   370   308   371   440   372   441   516   442  
+     151   196   152   197   248   198   249   306   250  
+     520   601   603   602   689   691   690   783   785  
+     310   373   375   374   443   445   444   519   521  
+     154   199   201   200   251   253   252   309   311  
+      52    79    81    80   113   115   114   153   155  
+       4    13    15    14    29    31    30    51    53  
+      35    17    58    34    16    57    33    32    56  
+     157   156   204   203   202   256   255   254   314  
+      55    54    84    83    82   118   117   116   158  
+     122    86   163   121    85   162   120   119   161  
+     125    89   166   124    88   165   123    87   164  
+     787   786   888   887   886   994   993   992  1106  
+     523   522   606   605   604   694   693   692   788  
+     313   312   378   377   376   448   447   446   524  
+     790   789   891   890   889   997   996   995  1109  
+     526   525   609   608   607   697   696   695   791  
+     316   315   381   380   379   451   450   449   527  
+     160   159   207   206   205   259   258   257   317  
+     263   209   322   262   208   321   261   260   320  
+     461   389   538   460   388   537   459   387   536  
+     266   212   325   265   211   324   264   210   323  
+     793   792   894   893   892  1000   999   998  1112  
+     529   528   612   611   610   700   699   698   794  
+     319   318   384   383   382   454   453   452   530  
+     710   620   805   709   619   804   708   618   803  
+     713   623   808   712   622   807   711   621   806  
+    1016   908  1129  1015   907  1128  1014   906  1127  
+    1019   911  1132  1018   910  1131  1017   909  1130  
+     796   795   897   896   895  1003  1002  1001  1115  
+     532   531   615   614   613   703   702   701   797  
+     458   386   535   457   385   534   456   455   533  
+     799   798   900   899   898  1006  1005  1004  1118  
+     707   617   802   706   616   801   705   704   800  
+    1013   905  1126  1012   904  1125  1011   903  1124  
+#FACT Irregular-Patches (SoftIDs)
+    1348  1419  1249  1349  1420  1250  1350  1421  1251  
+    1345  1416  1246  1346  1417  1247  1347  1418  1248  
+    1256  1142  1141  1255  1028  1027   919  1026   918  
+    1140  1254  1139  1353  1253  1352  1252  1438  1351  
+    1356  1355  1260  1146  1354  1259  1258  1257  1143  
+    1424  1359  1358  1263  1423  1422  1357  1262  1261  
+    1365  1429  1364  1363  1268  1362  1267  1266  1152  
+    1428  1427  1426  1361  1425  1360  1265  1264  1149  
+    1273  1367  1272  1158  1366  1271  1270  1269  1155  
+    1160  1161  1159  1045  1046  1044   936   937   935  
+    1368  1274  1275  1162  1369  1276  1277  1278  1165  
+    1430  1370  1371  1372  1373  1279  1280  1281  1168  
+    1431  1432  1433  1374  1434  1375  1282  1283  1171  
+    1435  1376  1377  1284  1436  1437  1378  1285  1286  
+    1379  1380  1287  1174  1381  1288  1289  1290  1177  
+    1291  1178  1179  1180  1062  1063   953   954   850  
+    1064  1181  1292  1065  1182  1293  1439  1183  1294  
+    1297  1186  1384  1296  1185  1383  1295  1184  1382  
+    1300  1189  1387  1299  1188  1386  1298  1187  1385  
+    1306  1195  1393  1305  1194  1392  1304  1193  1391  
+    1303  1192  1390  1302  1191  1389  1301  1190  1388  
+     970   866   971   867   972   973  1084  1200  1201  
+    1196  1307  1197  1308  1081  1198  1082  1199  1083  
+    1085  1202  1203  1309  1087  1088  1204  1310  1205  
+    1090  1206  1091  1207  1311  1312  1394  1313  1395  
+    1094  1210  1211  1317  1399  1318  1400  1319  1401  
+    1208  1209  1093  1316  1315  1396  1397  1314  1398  
+    1096  1212  1097  1213  1214  1320  1215  1321  1322  
+    1099   989  1100  1216   990  1101  1103  1217  1102  
+     784   883   885   884   991  1105  1104  1219  1218  
+    1108  1107  1223  1222  1221  1220  1325  1324  1323  
+    1110  1225  1224  1328  1327  1404  1326  1403  1402  
+    1111  1227  1226  1329  1331  1330  1407  1406  1405  
+    1114  1113  1229  1228  1334  1333  1332  1409  1408  
+    1119  1233  1232  1336  1117  1116  1231  1230  1335  
+    1010   902  1009   901  1008  1007  1120  1235  1234  
+    1239  1338  1238  1337  1123  1237  1122  1236  1121  
+    1339  1410  1240  1340  1411  1241  1341  1412  1242  
+    1342  1413  1243  1343  1414  1244  1344  1415  1245  
Index: trunk/Mars/resmc/fact-trigger-sum.txt
===================================================================
--- trunk/Mars/resmc/fact-trigger-sum.txt	(revision 9878)
+++ trunk/Mars/resmc/fact-trigger-sum.txt	(revision 9878)
@@ -0,0 +1,162 @@
+#FACT Trigger-Patches (SoftIDs)
+    1025   917  1138  1024   916  1137  1023   915  1136  
+    1022   914  1135  1021   913  1134  1020   912  1133  
+    1145  1031  1144  1030   922  1029   921   819   920  
+    1148  1034  1147  1033   925  1032   924   822   923  
+     821   725   820   724   634   723   633   549   632  
+     548   470   547   469   397   546   468   396   545  
+     818   722   817   721   631   816   720   630   815  
+     719   629   814   718   628   813   717   627   812  
+     716   626   811   715   625   810   714   624   809  
+     467   395   544   466   394   543   465   393   542  
+    1151  1037  1150  1036   928  1035   927   825   926  
+     824   728   823   727   637   726   636   552   635  
+     551   473   550   472   400   471   399   333   398  
+     332   272   331   271   217   330   270   216   329  
+     269   215   328   268   214   327   267   213   326  
+     464   392   541   463   391   540   462   390   539  
+    1154  1040  1153  1039   931  1038   930   828   929  
+     827   731   826   730   640   729   639   555   638  
+     554   476   553   475   403   474   402   336   401  
+     335   275   334   274   220   273   219   171   218  
+     170   128   169   127    91   168   126    90   167  
+     173   131   172   130    94   129    93    63    92  
+      62    38    61    37    19    60    36    18    59  
+    1157  1043  1156  1042   934  1041   933   831   932  
+     830   734   829   733   643   732   642   558   641  
+     557   479   556   478   406   477   405   339   404  
+     338   278   337   277   223   276   222   174   221  
+     833   834   832   736   737   735   645   646   644  
+     560   561   559   481   482   480   408   409   407  
+     341   342   340   280   281   279   225   226   224  
+     176   177   175   133   134   132    96    97    95  
+      65    66    64    40    41    39    21    22    20  
+      68    69    42    43    44    23    24    45    10  
+       8     9     7     1     2     6     0     3     5  
+     344   345   282   283   284   227   228   229   178  
+     179   180   135   136   137    98    99   100    67  
+     182   183   138   139   140   101   102   141    70  
+     103   142    71   104   143    72   105   144    73  
+    1163  1164  1047  1048  1049   938   939   940   835  
+     836   837   738   739   740   647   648   649   562  
+     563   564   483   484   485   410   411   412   343  
+    1166  1167  1050  1051  1052   941   942   943   838  
+     839   840   741   742   743   650   651   652   565  
+     566   567   486   487   488   413   414   415   346  
+     347   348   285   286   287   230   231   232   181  
+     350   351   288   289   290   233   234   291   184  
+     421   496   353   422   497   354   423   498   355  
+     235   292   185   236   293   186   237   294   187  
+    1169  1170  1053  1054  1055   944   945   946   841  
+     842   843   744   745   746   653   654   655   568  
+     569   570   489   490   491   416   417   418   349  
+     661   754   575   662   755   576   663   756   577  
+     664   757   578   665   758   579   666   759   580  
+     958  1069   854   959  1070   855   960  1071   856  
+     961  1072   857   962  1073   858   963  1074   859  
+    1172  1173  1056  1057  1058   947   948   949   844  
+     845   846   747   748   749   656   657   658   571  
+     572   573   492   493   494   419   420   495   352  
+    1175  1176  1059  1060  1061   950   951   952   847  
+     848   849   750   751   752   659   660   753   574  
+     955  1066   851   956  1067   852   957  1068   853  
+     967  1078   863   968  1079   864   969  1080   865  
+     964  1075   860   965  1076   861   966  1077   862  
+     769   868   770   869   974   870   975  1086   976  
+     772   871   773   872   977   873   978  1089   979  
+     508   589   509   590   677   591   678   771   679  
+     430   505   362   431   506   363   432   507   433  
+     673   766   587   674   767   588   675   768   676  
+     670   763   584   671   764   585   672   765   586  
+     427   502   359   428   503   360   429   504   361  
+     667   760   581   668   761   582   669   762   583  
+     775   874   776   875   980   876   981  1092   982  
+     511   592   512   593   680   594   681   774   682  
+     301   364   302   365   434   366   435   510   436  
+     241   298   191   242   299   192   243   300   244  
+     238   295   188   239   296   189   240   297   190  
+     424   499   356   425   500   357   426   501   358  
+     778   877   779   878   983   879   984  1095   985  
+     514   595   515   596   683   597   684   777   685  
+     304   367   305   368   437   369   438   513   439  
+     148   193   149   194   245   195   246   303   247  
+     106   145    74   107   146    75   108   147   109  
+      49    76    50    77   110    78   111   150   112  
+      25    46    11    26    47    12    27    48    28  
+     781   880   782   881   986   882   987  1098   988  
+     517   598   518   599   686   600   687   780   688  
+     307   370   308   371   440   372   441   516   442  
+     151   196   152   197   248   198   249   306   250  
+     520   601   603   602   689   691   690   783   785  
+     310   373   375   374   443   445   444   519   521  
+     154   199   201   200   251   253   252   309   311  
+      52    79    81    80   113   115   114   153   155  
+       4    13    15    14    29    31    30    51    53  
+      35    17    58    34    16    57    33    32    56  
+     157   156   204   203   202   256   255   254   314  
+      55    54    84    83    82   118   117   116   158  
+     122    86   163   121    85   162   120   119   161  
+     125    89   166   124    88   165   123    87   164  
+     787   786   888   887   886   994   993   992  1106  
+     523   522   606   605   604   694   693   692   788  
+     313   312   378   377   376   448   447   446   524  
+     790   789   891   890   889   997   996   995  1109  
+     526   525   609   608   607   697   696   695   791  
+     316   315   381   380   379   451   450   449   527  
+     160   159   207   206   205   259   258   257   317  
+     263   209   322   262   208   321   261   260   320  
+     461   389   538   460   388   537   459   387   536  
+     266   212   325   265   211   324   264   210   323  
+     793   792   894   893   892  1000   999   998  1112  
+     529   528   612   611   610   700   699   698   794  
+     319   318   384   383   382   454   453   452   530  
+     710   620   805   709   619   804   708   618   803  
+     713   623   808   712   622   807   711   621   806  
+    1016   908  1129  1015   907  1128  1014   906  1127  
+    1019   911  1132  1018   910  1131  1017   909  1130  
+     796   795   897   896   895  1003  1002  1001  1115  
+     532   531   615   614   613   703   702   701   797  
+     458   386   535   457   385   534   456   455   533  
+     799   798   900   899   898  1006  1005  1004  1118  
+     707   617   802   706   616   801   705   704   800  
+    1013   905  1126  1012   904  1125  1011   903  1124  
+#FACT Irregular-Patches (SoftIDs)
+#    1348  1419  1249  1349  1420  1250  1350  1421  1251  
+#    1345  1416  1246  1346  1417  1247  1347  1418  1248  
+#    1256  1142  1141  1255  1028  1027   919  1026   918  
+#    1140  1254  1139  1353  1253  1352  1252  1438  1351  
+#    1356  1355  1260  1146  1354  1259  1258  1257  1143  
+#    1424  1359  1358  1263  1423  1422  1357  1262  1261  
+#    1365  1429  1364  1363  1268  1362  1267  1266  1152  
+#    1428  1427  1426  1361  1425  1360  1265  1264  1149  
+#    1273  1367  1272  1158  1366  1271  1270  1269  1155  
+#    1160  1161  1159  1045  1046  1044   936   937   935  
+#    1368  1274  1275  1162  1369  1276  1277  1278  1165  
+#    1430  1370  1371  1372  1373  1279  1280  1281  1168  
+#    1431  1432  1433  1374  1434  1375  1282  1283  1171  
+#    1435  1376  1377  1284  1436  1437  1378  1285  1286  
+#    1379  1380  1287  1174  1381  1288  1289  1290  1177  
+#    1291  1178  1179  1180  1062  1063   953   954   850  
+#    1064  1181  1292  1065  1182  1293  1439  1183  1294  
+#    1297  1186  1384  1296  1185  1383  1295  1184  1382  
+#    1300  1189  1387  1299  1188  1386  1298  1187  1385  
+#    1306  1195  1393  1305  1194  1392  1304  1193  1391  
+#    1303  1192  1390  1302  1191  1389  1301  1190  1388  
+#     970   866   971   867   972   973  1084  1200  1201  
+#    1196  1307  1197  1308  1081  1198  1082  1199  1083  
+#    1085  1202  1203  1309  1087  1088  1204  1310  1205  
+#    1090  1206  1091  1207  1311  1312  1394  1313  1395  
+#    1094  1210  1211  1317  1399  1318  1400  1319  1401  
+#    1208  1209  1093  1316  1315  1396  1397  1314  1398  
+#    1096  1212  1097  1213  1214  1320  1215  1321  1322  
+#    1099   989  1100  1216   990  1101  1103  1217  1102  
+#     784   883   885   884   991  1105  1104  1219  1218  
+#    1108  1107  1223  1222  1221  1220  1325  1324  1323  
+#    1110  1225  1224  1328  1327  1404  1326  1403  1402  
+#    1111  1227  1226  1329  1331  1330  1407  1406  1405  
+#    1114  1113  1229  1228  1334  1333  1332  1409  1408  
+#    1119  1233  1232  1336  1117  1116  1231  1230  1335  
+#    1010   902  1009   901  1008  1007  1120  1235  1234  
+#    1239  1338  1238  1337  1123  1237  1122  1236  1121  
+#    1339  1410  1240  1340  1411  1241  1341  1412  1242  
+#    1342  1413  1243  1343  1414  1244  1344  1415  1245  