Index: firmware/FTU/rs485/FTU_rs485_control.vhd
===================================================================
--- firmware/FTU/rs485/FTU_rs485_control.vhd	(revision 9928)
+++ firmware/FTU/rs485/FTU_rs485_control.vhd	(revision 9939)
@@ -3,7 +3,7 @@
 -- Engineer:       Q. Weitzel, P. Vogler
 -- 
--- Create Date:    09/13/2010 
+-- Create Date:    09/13/2010
 -- Design Name: 
--- Module Name:    FTU_rs485_control - Behavioral 
+-- Module Name:    FTU_rs485_control - Behavioral
 -- Project Name: 
 -- Target Devices: 
@@ -11,5 +11,5 @@
 -- Description:    top level entity of FTU RS485 module
 --
--- Dependencies: 
+-- Dependencies:
 --
 -- Revision: 
@@ -50,12 +50,11 @@
     tx_d                    : OUT std_logic;
     tx_en                   : OUT std_logic;
-    new_DACs                : OUT std_logic;  -- new DACs arrived via RS485
-    new_enables             : OUT std_logic;  -- new enables arrived via RS485
-    new_prescaling          : OUT std_logic;  -- new prescaling arrived via RS485
-    read_rates              : OUT std_logic;  -- FTM wants to read rates
-    read_DACs               : OUT std_logic;  -- FTM wants to read DACs
-    read_enables            : OUT std_logic;  -- FTM wants to read enable pattern
-    read_prescaling         : OUT std_logic;  -- FTM wants to read prescaling value
-    --rs485_error           : OUT std_logic;  -- to be discussed!
+    new_DACs                : OUT std_logic := '0';  -- new DACs arrived via RS485
+    new_enables             : OUT std_logic := '0';  -- new enables arrived via RS485
+    new_prescaling          : OUT std_logic := '0';  -- new prescaling arrived via RS485
+    read_rates              : OUT std_logic := '0';  -- FTM wants to read rates
+    read_DACs               : OUT std_logic := '0';  -- FTM wants to read DACs
+    read_enables            : OUT std_logic := '0';  -- FTM wants to read enable pattern
+    read_prescaling         : OUT std_logic := '0';  -- FTM wants to read prescaling value
     dac_array_rs485_out     : OUT dac_array_type;
     enable_array_rs485_out  : OUT enable_array_type;
@@ -278,5 +277,5 @@
         when SET_DAC_WAIT=>  -- wait until FTU control says "done" and then answer to FTM
           if (DACs_ready = '1') then
-            new_DACs <= '0';            
+            new_DACs <= '0';
             FTU_rs485_control_State <= SET_DAC_TRANSMIT;
           else
@@ -288,5 +287,5 @@
           if (enables_ready = '1') then
             new_enables <= '0';
-            FTU_rs485_control_State <= RECEIVE;
+            FTU_rs485_control_State <= SET_ENABLE_TRANSMIT;
           else
             new_enables <= '1';
@@ -297,5 +296,5 @@
           if (prescaling_ready = '1') then
             new_prescaling <= '0';
-            FTU_rs485_control_State <= RECEIVE;
+            FTU_rs485_control_State <= SET_PRESCALING_TRANSMIT;
           else
             new_prescaling <= '1';
@@ -306,5 +305,5 @@
           if (rates_ready = '1') then
             read_rates <= '0';
-            FTU_rs485_control_State <= RECEIVE;
+            FTU_rs485_control_State <= READ_RATES_TRANSMIT;
           else
             read_rates <= '1';
@@ -315,5 +314,5 @@
           if (DACs_ready = '1') then
             read_DACs <= '0';
-            FTU_rs485_control_State <= RECEIVE;
+            FTU_rs485_control_State <= READ_DAC_TRANSMIT;
           else
             read_DACs <= '1';
@@ -324,5 +323,5 @@
           if (enables_ready = '1') then
             read_enables <= '0';
-            FTU_rs485_control_State <= RECEIVE;
+            FTU_rs485_control_State <= READ_ENABLE_TRANSMIT;
           else
             read_enables <= '1';
@@ -333,5 +332,5 @@
           if (prescaling_ready = '1') then
             read_prescaling <= '0';
-            FTU_rs485_control_State <= RECEIVE;
+            FTU_rs485_control_State <= READ_PRESCALING_TRANSMIT;
           else
             read_prescaling <= '1';
Index: firmware/FTU/rs485/FTU_rs485_interpreter.vhd
===================================================================
--- firmware/FTU/rs485/FTU_rs485_interpreter.vhd	(revision 9928)
+++ firmware/FTU/rs485/FTU_rs485_interpreter.vhd	(revision 9939)
@@ -110,10 +110,12 @@
             int_read_enables    <= '0';  
             int_read_prescaling <= '0';
-            dac_array_rs485_out_sig <= (conv_integer(unsigned(data_block(47 downto 32))),
-                                        conv_integer(unsigned(data_block(63 downto 48))),
-                                        conv_integer(unsigned(data_block(79 downto 64))),
-                                        conv_integer(unsigned(data_block(95 downto 80))),
-                                        0,0,0,
-                                        conv_integer(unsigned(data_block(111 downto 96)))
+            dac_array_rs485_out_sig <= (conv_integer(unsigned(data_block(43 downto 32))),
+                                        conv_integer(unsigned(data_block(59 downto 48))),
+                                        conv_integer(unsigned(data_block(75 downto 64))),
+                                        conv_integer(unsigned(data_block(91 downto 80))),
+                                        DEFAULT_DAC(4),
+                                        DEFAULT_DAC(5),
+                                        DEFAULT_DAC(6),
+                                        conv_integer(unsigned(data_block(107 downto 96)))
                                         );
             FTU_rs485_interpreter_State <= WAIT_FOR_DATA;